#include "wiz.h"
#include "globals.h"
#include "backbuffer.h"
#include "config.h"

void wizFixKeystate(Uint8 *kst)
{
    if (SDL_JoystickGetButton(joy, VK_VOL_DOWN) && SDL_JoystickGetButton(joy, VK_VOL_UP)) {
        wizPostprocessFlag = !wizPostprocessFlag;
        //fprintf(f, "wizPostprocessFlag = %d\n\r", wizPostprocessFlag);
    }
    kst[KEY_ESC] =   SDL_JoystickGetButton(joy, VK_START) && SDL_JoystickGetButton(joy, VK_SELECT);
    kst[KEY_E]=      SDL_JoystickGetButton(joy, VK_FA);
    //kst[KEY_F4] =    SDL_JoystickGetButton(joy, VK_SELECT);
    kst[KEY_LEFT] =  SDL_JoystickGetButton(joy, VK_LEFT)||SDL_JoystickGetButton(joy, VK_UP_LEFT)||SDL_JoystickGetButton(joy, VK_DOWN_LEFT);
    kst[KEY_RIGHT] = SDL_JoystickGetButton(joy, VK_RIGHT) || SDL_JoystickGetButton(joy, VK_UP_RIGHT) || SDL_JoystickGetButton(joy, VK_DOWN_RIGHT);
    kst[KEY_UP] =    SDL_JoystickGetButton(joy, VK_UP)||SDL_JoystickGetButton(joy, VK_UP_LEFT)||SDL_JoystickGetButton(joy, VK_UP_RIGHT);
    kst[KEY_DOWN] =  SDL_JoystickGetButton(joy, VK_DOWN)||SDL_JoystickGetButton(joy, VK_DOWN_LEFT)||SDL_JoystickGetButton(joy, VK_DOWN_RIGHT);
    kst[KEY_JUMP] =  SDL_JoystickGetButton(joy, VK_FX) || SDL_JoystickGetButton(joy, VK_UP);
    kst[KEY_SPACE] = SDL_JoystickGetButton(joy, VK_FB);
    //kst[KEY_F2] =    SDL_JoystickGetButton(joy, VK_FL) && SDL_JoystickGetButton(joy, VK_FR);
    kst[KEY_F1] =    SDL_JoystickGetButton(joy, VK_FR);
    kst[SDLK_s] =    SDL_JoystickGetButton(joy, VK_FL);
}

void wizFixEventKeyUp(SDL_Event *ev)
{
    //used only in reset.c: 158
    if ( ev->jbutton.button == VK_START || ev->jbutton.button == VK_FB ) {
        ev->type = SDL_KEYUP;
        ev->key.keysym.sym = KEY_ENTER;
    }
}

void wizFixEvent(SDL_Event *ev)
{
    ev->type = SDL_KEYDOWN;
    if (SDL_JoystickGetButton(joy, VK_START) && SDL_JoystickGetButton(joy, VK_SELECT)) {
        ev->key.keysym.sym = KEY_ESC;
    }
    else switch(ev->jbutton.button) {
        case VK_FY :
            ev->key.keysym.sym = KEY_MUSIC;
            break;
        case VK_START :
            ev->key.keysym.sym = KEY_ENTER;
            break;
        case VK_FB :
            ev->key.keysym.sym = KEY_SPACE;
            break;
        case VK_UP :
            ev->key.keysym.sym = SDLK_UP;
            break;
        case VK_DOWN :
            ev->key.keysym.sym = SDLK_DOWN;
            break;
        case VK_VOL_DOWN :
            ev->key.keysym.sym = KEY_GODMODE;
            break;
        case VK_VOL_UP :
            ev->key.keysym.sym = KEY_NOCLIP;
            break;
        case VK_SELECT :
            ev->key.keysym.sym = KEY_P;
            break;
    }
}


void wizPostprocess(SDL_Surface *srf)
{
    if (wizPostprocessFlag) {
        SDL_Rect wizS;
        //SDL_FillRect(wizSurface, NULL, SDL_MapRGB(wizSurface->format, 0, 0, 0));
        wizS.x = 0;
        wizS.y = 0;
        wizS.w = 320;
        wizS.h = 200;
        SDL_SoftStretch(screen, &wizS, wizSurface, NULL);
        SDL_BlitSurface(wizSurface, NULL, screen, NULL);
    }
}


